"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.connect = connect;
exports.disconnect = disconnect;
exports.isActive = isActive;
exports.getTeleport = getTeleport;
var vue_demi_1 = require("vue-demi");
var active = false;
var items = (0, vue_demi_1.reactive)({});
function connect(id, component, container, node, graph) {
    if (active) {
        items[id] = (0, vue_demi_1.markRaw)((0, vue_demi_1.defineComponent)({
            render: function () {
                return (0, vue_demi_1.h)(vue_demi_1.Teleport, { to: container }, [
                    (0, vue_demi_1.h)(component, { node: node, graph: graph }),
                ]);
            },
            provide: function () { return ({
                getNode: function () { return node; },
                getGraph: function () { return graph; },
            }); },
        }));
    }
}
function disconnect(id) {
    if (active) {
        delete items[id];
    }
}
function isActive() {
    return active;
}
function getTeleport() {
    if (!vue_demi_1.isVue3) {
        throw new Error('teleport is only available in Vue3');
    }
    active = true;
    return (0, vue_demi_1.defineComponent)({
        setup: function () {
            return function () {
                return (0, vue_demi_1.h)(vue_demi_1.Fragment, {}, Object.keys(items).map(function (id) { return (0, vue_demi_1.h)(items[id]); }));
            };
        },
    });
}
//# sourceMappingURL=teleport.js.map